/**********************************************************************
*                        MEKATRONIX Copyright 1998
*
* Title        sensetjp.c
* Programmers  Keith L. Doty
* Date         Sept. 09, 1998
* Version      1

* Description 
This program outputs the values of the IR detectors and the bumper switches
continuously. This program lets you test the basic sensor suite of the
TJ Pro robot.

A physical, serial communication link must be present, e.g. the standard
Mekatronix serial cable connection via the MB2325 board.

Serial Protocol of this program:
  baud=9300, 8 data bits, 1 stop bit, no parity, no flow control.
 
 Example: 
   Configure Hyperterm on Win95:
   Direct to COM1, 9300 baud, 8 bits, no parity, 1 stop bit,
   no flow control.

**********************************************************************/

/*************************** Includes ********************************/
#include <lftjpb.h>
#include <linef.h>
#define ERR 0
#define ERRM 35
#define TURNT 800
#define ACCEL_RATE 20
#define MAX_ACCEL 35
#define MIN_ACCEL 15
#define MIN_SPEED 25
#define MAX_SPEED2 28


 int irdr, irdl, speedr, speedl;
 int temp7, temp8,temp9, temp10;
  int initp1, initp2, initpl1, initpl2, accel, off_left, off_right, temp1, temp2,temp3, temp4, temp5,  curp1, curp2, flag;
  int curpl1, curpl2;
  int slow_down;
  
/************************ End of Includes ****************************/

void turn(void);
void read_cds(void);
void run_motor(int speedr, int speedl, int time);
/***************************** Main **********************************/
void main(void)
{



  init_analog();
  init_clocktjp();
  init_serial();
 
  init_motortjp();

  IRE_ON;     /* turn on IR emitters */
	initp1 = PHOTO1;
	initp2 = PHOTO2;
  
	START;
	temp1 = PHOTO1;
	wait(50);
	temp2 = PHOTO1;
	wait(50);
	temp3 = PHOTO1;
	wait(50);
	temp4 = PHOTO1;
	initp1 = ((temp1 + temp2 + temp3 + temp4)/4);
	wait(50);
	temp1 = PHOTO2;
	wait(50);
	temp2 = PHOTO2;
	wait(50);
	temp3 = PHOTO2;
	wait(50);
	temp4 = PHOTO2;
	initp2 = ((temp1 + temp2 + temp3 + temp4)/4);
	wait(50);
	temp1 = PHOTOL1;
	wait(50);
	temp2 = PHOTOL1;
	wait(50);
	temp3 = PHOTOL1;
	wait(50);
	temp4 = PHOTOL1;
	initpl1 = ((temp1 + temp2 + temp3 + temp4)/4);
	wait(50);
	temp1 = PHOTOL2;
	wait(50);
	temp2 = PHOTOL2;
	wait(50);
	temp3 = PHOTOL2;
	wait(50);
	temp4 = PHOTOL2;
	initpl2 = ((temp1 + temp2 + temp3 + temp4)/4);
	flag = 0;
	speedr = 20;
	speedl = 20;
	off_left = 0;
	off_right = 0;
	accel= ACCEL_RATE;
	
  while(1)
  {	read_cds();
	    printf("\x1b[10;0H   \b\b\b\b%d",PHOTO1);
    printf("\x1b[10;10H   \b\b\b\b%d",PHOTO2);
    printf("\x1b[10;20H   \b\b\b\b%d",PHOTOL1);
    printf("\x1b[10;30H   \b\b\b\b%d",PHOTOL2);
	if ((flag == 0) & P_ALL_ON)
	{	off_left = 0;
		off_right = 0;
		read_cds();
		speedr = speedl;
		speedr = speedr + 1;
		speedl = speedr + 1;
		accel = accel+ 4;
		if (accel > MAX_ACCEL) accel = MAX_ACCEL;
		if ((speedr == MAX_SPEED2) | (speedl = MAX_SPEED2)) {speedr = MAX_SPEED2; speedl = MAX_SPEED2;	}
		run_motor(speedr, speedl, accel);
    	flag = 0;	
    	
	}
	
	/*while ((flag == 0) & (!P_FNT_OFF & P_LFT_OFF & P_RGT_OFF))
	{	
		off_left = 0;
		off_right = 0;
		read_cds();
		speedr = speedl;
		speedr = speedr + 1;
		speedl = speedr + 1;
		if ((speedr == MAX_SPEED2) | (speedl = MAX_SPEED2)) {speedr = MAX_SPEED2; speedl = MAX_SPEED2;	}
		run_motor(speedr, speedl, ACCEL_RATE);
    	flag = 0;	
    	
	}*/
	while ((flag == 0) & (P_LFT_OFF | (P_LFT_OFF & P_FNT_OFF)))
	{			    printf("\x1b[10;0H   \b\b\b\b%d",PHOTO1);
    printf("\x1b[10;10H   \b\b\b\b%d",PHOTO2);
    printf("\x1b[10;20H   \b\b\b\b%d",PHOTOL1);
    printf("\x1b[10;30H   \b\b\b\b%d",PHOTOL2);
			accel = accel - 4;
			off_left = 1;
			off_right = 0;
			read_cds();
			speedr = speedr - 1;
       		speedl = speedl + 1;
       		if (accel < MIN_ACCEL) accel = MIN_ACCEL;
       		if ((speedr <= MIN_SPEED + 15) | (speedl <= MIN_SPEED+ 15)) {speedr = MIN_SPEED+15;}
       		if ((speedl >= MAX_SPEED2 + 20)) {speedl = MAX_SPEED2 + 20;}
			run_motor(speedr, speedl, accel);
    		flag = 0;	
    	
    }
   while ((flag == 0) & (P_RGT_OFF | (P_RGT_OFF & P_FNT_OFF)))
	{		    printf("\x1b[10;0H   \b\b\b\b%d",PHOTO1);
    printf("\x1b[10;10H   \b\b\b\b%d",PHOTO2);
    printf("\x1b[10;20H   \b\b\b\b%d",PHOTOL1);
    printf("\x1b[10;30H   \b\b\b\b%d",PHOTOL2);
			off_left = 0;
			off_right = 1;
			read_cds();
			speedr = speedr + 4;
       		speedl = speedl - 2;
       		accel = accel - 4;
       		if (accel < MIN_ACCEL) accel = MIN_ACCEL;
       		if ((speedr <= MIN_SPEED + 5) | (speedl <= MIN_SPEED) + 5) {speedl = MIN_SPEED + 5;}
       		if ((speedr >= MAX_SPEED2 + 20)) {speedr = MAX_SPEED2 + 20;}
			run_motor(speedr, speedl, accel);
    		flag = 0;	
    	
    }
    /*if ((flag == 0) & (P_FNT_OFF) & (P_LFT_OFF) & (P_RGT_OFF))
    {  if (off_left == 1)
		{	read_cds();
    		if (speedr > 0) speedr=-speedl;
    		speedr = speedr - 1;
       		speedl = speedl + 2;
       		if ((speedr <= MAX_SPEED2)) {speedr = -MAX_SPEED2;}
       		if ((speedl >= MAX_SPEED2 - 2)) {speedl = MAX_SPEED2 - 2;}
       		run_motor(speedr, speedl, ACCEL_RATE + 10);
       		off_left == 0;
    		flag = 0;}
    	if (off_right == 1)
    	{	read_cds();
    		if (speedl > 0) speedl=-speedr;
    		speedr = speedr + 3;
       		speedl = speedl - 1;
       		if ((speedl <= -MAX_SPEED2 + 5)) {speedl = -MAX_SPEED2 + 5;}
       		if ((speedr >= MAX_SPEED2 + 7)) {speedr = MAX_SPEED2 +7;}
       		run_motor(speedr, speedl, ACCEL_RATE + 10);
       		off_right = 0;
    		flag = 0;}
    }*/
    
    
    
  }/*end while(1)*/
}

void run_motor(int speedr, int speedl, int time)
{	motorp(RIGHT_MOTOR, speedr); 
   	motorp(LEFT_MOTOR, speedl);
   	wait(time);}
   	
void read_cds(void)
{
temp1 = PHOTO1;
  	if (temp1 < initp1-ERRM) temp1 = PHOTO1;
	temp2 = PHOTO1;
	if (temp2 < initp1-ERRM) temp2 = PHOTO1;
	temp3 = PHOTO1;
	if (temp3 < initp1-ERRM) temp3 = PHOTO1;
	temp4 = PHOTO1;
	if (temp4 < initp1-ERRM) temp4 = PHOTO1;
	curp1 = ((temp1 + temp2 + temp3 + temp4)/4);
	temp1 = PHOTO2;
 	if (temp1 < initp2-ERRM) temp1 = PHOTO2;
	temp2 = PHOTO2;
	if (temp2 < initp2-ERRM) temp2 = PHOTO2;
	temp3 = PHOTO2;
	if (temp3 < initp2-ERRM) temp3 = PHOTO2;
	temp4 = PHOTO2;
	if (temp4 < initp2-ERRM) temp4 = PHOTO2;
	curp2 = ((temp1 + temp2 + temp3 + temp4)/4);
	temp1 = PHOTOL1;
	if (temp1 < initpl1-ERRM) temp1 = PHOTOL1;
	temp2 = PHOTOL1;
	if (temp2 < initpl1-ERRM) temp2 = PHOTOL1;
	temp3 = PHOTOL1;
	if (temp3 < initpl1-ERRM) temp3 = PHOTOL1;
	temp4 = PHOTOL1;
	if (temp4 < initpl1-ERRM) temp4 = PHOTOL1;
	curpl1 = ((temp1 + temp2 + temp3 + temp4)/4);
	temp1 = PHOTOL2;
 	if (temp1 < initpl2-ERRM) temp1 = PHOTOL2;
	temp2 = PHOTOL2;
	if (temp2 < initpl2-ERRM) temp2 = PHOTOL2;
	temp3 = PHOTOL2;
	if (temp3 < initpl2-ERRM) temp3 = PHOTOL2;
	temp4 = PHOTOL2;
	if (temp4 < initpl2-ERRM) temp4 = PHOTOL2;
	curpl2 = ((temp1 + temp2 + temp3 + temp4)/4);}
/***************************** End of Main **********************************/
void turn(void)
/************************************************************************
 * Function:  Will turn in a random direction for a "random" amount of  *
 *            time, dictated by the fast changine lower bits in		*
 *	      mseconds().  					        *
 * Returns:  None                                                       *
 *                                                                      *
 * Inputs                                                               *
 *   Parameters: None                                                   *
 *   Globals:    None                                                   *
 *   Registers:  TCNT                                                   *
 * Outputs                                                              *
 *   Parameters: None                                                   *
 *   Globals:    None                                                   *
 *   Registers:  None                                                   *
 * Functions called: motorp(), wait()					*
 * Notes:                                                               *
 ************************************************************************/
{
 int i;
 unsigned rand;

 rand = TCNT;

 if (rand & 0x0001)
 /*turn left*/
 {
   motorp(RIGHT_MOTOR, 70);
   motorp(LEFT_MOTOR, -30);
 }
 else
 /*turn right*/
 {
   motorp(RIGHT_MOTOR, -70);
   motorp(LEFT_MOTOR, 30);
 }

 i=(rand % 1024);
 if(i>250) wait(i); else wait(250);

}

